#include <stdlib.h>
#include "archgtus.h"

int p_mob;

int compmax(const void *in1,const void *in2) {
  gt_move *en1=(gt_move *)in1,*en2=(gt_move *)in2;
  return (en1->val)-(en2->val);
}

int compmin(const void *in1, const void *in2) {
  gt_move *en1=(gt_move *)in1,*en2=(gt_move *)in2;
  return (en2->val)-(en1->val);
}

void Gt_generate_moves(gt_mimx_data *current_mimx_data,gt_moves *array_of_moves) {
  int i;
  score s;
  gt_unmove unmove;
  if(current_mimx_data->depth==max_depth) /*check if the recursion depth exceedes the maximum depth */
    array_of_moves->num_moves=0;          /*if true return 0 moves */
  else {
    generate_jumps(&current_mimx_data->current_data, array_of_moves);
    if(array_of_moves->num_moves==0) {
      generate_non_jumps(&current_mimx_data->current_data, array_of_moves);
      /*otherwise generate a list of legal moves */
    }
    p_mob=array_of_moves->num_moves;
    for(i=0; i<array_of_moves->num_moves; i++) { /*find the value of the moves*/
      Gt_move(current_mimx_data, &array_of_moves->mlist[i], &unmove); /*apply the move to the board */
      current_mimx_data->depth++;
      if(p_mob==0 && current_mimx_data->depth<max_depth) {
	if(current_mimx_data->current_data.to_move==black) {
	  s=white_win_game(current_mimx_data->depth);
	  array_of_moves->mlist[i].val=-s.win_depth*3200;
	}
	else{
	  s=black_win_game(current_mimx_data->depth);
	  array_of_moves->mlist[i].val=s.win_depth*3200;
	}
      }
      else{
	s=static_evaluation(&current_mimx_data->current_data, &p_mob, current_mimx_data->depth);
	/*calculate the given position's value, the
	  score structure consists of 3 fields: stable
	  pieces, mobility and total pieces, each one
	  of them describing the board, and having a 
	  different weight in calculating the position's
	  value.*/
	/* black wants pos-infinity */
	//ratio=s.black_pieces-s.white_pieces;
	array_of_moves->mlist[i].val=(s.mobility/*+(ratio)*64*/+(s.black_pieces-s.white_pieces)*20);
      }
      Gt_unmove(current_mimx_data, &unmove);/*unapply the move*/
      current_mimx_data->depth--;
    }
    if ((current_mimx_data->parity+current_mimx_data->depth)%2)/*sort the moves in ascending on descending order*/
      qsort(array_of_moves->mlist,array_of_moves->num_moves,sizeof(gt_move),compmax);
    else
      qsort(array_of_moves->mlist,array_of_moves->num_moves,sizeof(gt_move),compmin);
  }
}

void Gt_move(gt_mimx_data *current_mimx_data,gt_move *coord,gt_unmove *unmove) {
  current_mimx_data->current_data.val=coord->val;
  *unmove=current_mimx_data->current_data;
  /*store the gt_unmove structure before applying the new move*/
  apply_move(&current_mimx_data->current_data, *coord);             /*apply the move*/
}

void Gt_unmove(gt_mimx_data *current_board,gt_unmove *unmove) {
  current_board->current_data=*unmove;
  /*restore the gt_data structure,i.e. unapply the move*/
}

void Gt_evaluate(gt_mimx_data *current_mimx_data, gt_score *chosen_score,gt_score best_score) {
  if(current_mimx_data->depth==max_depth)
    *chosen_score=current_mimx_data->current_data.val;
  else
    *chosen_score=best_score;
}
